//+------------------------------------------------------------------+
//|                                                 e-NightTrade.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|  06.02.2006   .                                    |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    --------------------------------
extern string _Parameters_Trade = "-----  ";


extern int  MinuteOpenPos = 0;      //   

extern int  StopLoss1      = 95;     //  
extern int  TakeProfit1    =60; //  
extern int  StopLoss2      = 100;    //  
extern int  TakeProfit2    = 15;  //  

extern bool UseClosePos   = True;   //   

extern bool   UseTrailing     = True;   //  
extern bool   ProfitTrailing  = True;   //   
extern int    TrailingStop   = 0;     //   
extern int    TrailingStep    = 0;      //  
//----    -------------------------------
double Lots        = 0.1;

int    Slippage    = 3;
int    MAGIC       = 20060206;
color  clOpenBuy   = LightBlue;
color  clOpenSell  = LightCoral;
color  clCloseBuy  = Blue;
color  clCloseSell = Red;
color  clModifyBuy   = Aqua;
color  clModifySell  = Tomato;
bool   UseSound      = True;
string NameFileSound = "expert.wav";



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
   if (  Minute()>=MinuteOpenPos && Minute()<=MinuteOpenPos) {
   
     if (Volume[0]>1 && !ExistPosition(MAGIC)) OpenPositions(OP_SELL);
   }
  if (  Minute()>=MinuteOpenPos && Minute()<=MinuteOpenPos) {
    
     
     if (Volume[0]>1 && !ExistPosition(MAGIC)) OpenPositions(OP_BUY);
   }

  if (UseTrailing) TrailingPositions();
  
  if (UseClosePos) {
    
    
    
    if(TimeCurrent()-OrderOpenTime()==600*4) CloseAllPositions(OP_SELL, MAGIC);
    if(TimeCurrent()-OrderOpenTime()==600*4) CloseAllPositions(OP_BUY, MAGIC);
    
    
  }
} 


//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenPositions(int type) {
  double ldStop=0, ldTake=0;
  int    bs=GetTradeSignal();

 

 
  if (bs<0) {
    if (type == OP_BUY) {
     Lots = 0.1;
      if (StopLoss2!=0)ldStop=Ask-StopLoss2*Point;
      if (TakeProfit2!=0)ldTake=Ask+TakeProfit2*Point;
      OpenPosition(OP_BUY,  ldStop, ldTake);
      
    }
  }
  if (bs>0) {      
    if (type == OP_SELL) {
     Lots = 0.1;
      if (StopLoss1!=0)ldStop=Bid+StopLoss1*Point;
      if (TakeProfit1!=0)ldTake=Bid-TakeProfit1*Point;
      OpenPosition(OP_SELL, ldStop, ldTake);
      
    }
  }
}

//+------------------------------------------------------------------+
//|   :                                      |
//|    1 -                                                    |
//|    0 - ,                                           |
//|   -1 -                                                   |
//+------------------------------------------------------------------+

 int GetTradeSignal() {
  int bs=0;
 
  double cl1=iClose(NULL, PERIOD_H4,1);
  double cl2=iOpen(NULL, PERIOD_H4,1);
 
  if ((cl2>cl1)) bs=1;
  double cl5=iClose(NULL, PERIOD_H4,1);
  double cl6=iOpen(NULL, PERIOD_H4,1);
 
  
    if ((cl5>cl6)) bs=-1;
  

  return(bs);


}
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool ExistPosition(int magic) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) {
          Exist=True; break;
        }
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   ldStop -                                            |
//|   ldTake -                                            |
//+------------------------------------------------------------------+
void OpenPosition(int op, double ldStop, double ldTake) {
  color  clOpen;
  double pp;

  if (op==OP_BUY) {
    clOpen=clOpenBuy; pp=Ask;
  } else {
    clOpen=clOpenSell; pp=Bid;
  }
  pp=NormalizeDouble(pp, Digits);
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,"",MAGIC,0,clOpen);
}
//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//|   mn     -   MAGIC                                      |
//+------------------------------------------------------------------+
void SetOrder(int op, double pp, double ldStop, double ldTake, int mn) {
  color  clOpen;
  
  if (op==OP_BUYSTOP) clOpen=clOpenBuy;
  else clOpen=clOpenSell;
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,0,MAGIC+mn,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions(int type,int magic) {
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != magic) continue;

    if (OrderType()!= type) continue;
    
    if (OrderType()==OP_BUY) {
      OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
    }
      if (OrderType()==OP_BUYSTOP) {
      OrderDelete(OrderTicket());
    } 
      if (OrderType()==OP_SELLSTOP) {
      OrderDelete(OrderTicket());
    }
    if (OrderType()==OP_SELL) {
      OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
    }
  }
}
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void TrailingPositions() {
  for (int i=1; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY) {
          if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*Point) {
            if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
              ModifyStopLoss(Bid-TrailingStop*Point, clModifyBuy);
            }
          }
        }
        if (OrderType()==OP_SELL) {
          if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*Point) {
            if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
              ModifyStopLoss(Ask+TrailingStop*Point, clModifySell);
            }
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//|   clModify   -                                    |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop, color clModify) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
  if (fm && UseSound) PlaySound(NameFileSound);
}

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

